--
--
-- BuyableRapeTable
-- specialization for Buyable Rape Table
--
-- author: Burner
-- date: 09.09.2013
--
--

BuyableRapeTable = {};

function BuyableRapeTable.initSpecialization()
	Vehicle.registerJointType("rapeTable");
end;

function BuyableRapeTable.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Attachable, specializations);
end;

function BuyableRapeTable:load(xmlFile)
	self.cutterExtraObjects = {};
	local i = 0;
	while true do
		local key = string.format("vehicle.cutterExtraObjects.cutterExtraObject(%d)", i);
		if not hasXMLProperty(xmlFile, key) then
			break;
		end;
		local showOnAttach = Utils.getNoNil(getXMLBool(xmlFile, key.."#showOnAttach"), false);
		local index = getXMLString(xmlFile, key.."#index");
		if index ~= nil then
			table.insert(self.cutterExtraObjects, {index=index, showOnAttach=showOnAttach});
		end;
		i = i +1;
	end;
	
	self.av = {};
	self.collisionMaskBackup = 0;
	--self.massBackup = getMass(self.components[1].node);
	--self.isSelectable = false;
end;

function BuyableRapeTable:mouseEvent(posX, posY, isDown, isUp, button)
end;

function BuyableRapeTable:delete()
end;

function BuyableRapeTable:keyEvent(unicode, sym, modifier, isDown)
end;

function BuyableRapeTable:readStream(streamId, connection)
end;

function BuyableRapeTable:writeStream(streamId, connection)
end;

function BuyableRapeTable:update(dt)
	if self.attacherVehicle ~= nil then
		if self.attacherVehicle.reelStarted then
			self:setAnimationTime(1, 1);
		else
			self:setAnimationTime(1, 0);
		end;
	end;
	if self.attacherVehicle ~= nil then
		for _, object in pairs(self.cutterExtraObjects) do
			local objectNode = Utils.indexToObject(self.attacherVehicle.components, object.index);
			if objectNode ~= nil then
				setVisibility(objectNode, object.showOnAttach);
			end;
		end;
	end;
end;

function BuyableRapeTable:updateTick(dt) 
end;

function BuyableRapeTable:draw()
end;

function BuyableRapeTable:onAttach(attacherVehicle)
	self.av = attacherVehicle;
	attacherVehicle.hasRapeTable = true;
	self.collisionMaskBackup = getCollisionMask(self.components[1].node);
	setCollisionMask(self.components[1].node, 1073741824);
	--setMass(self.components[1].node, 0);
	setCenterOfMass(self.rootNode, 0, 0, 1.8);
end;

function BuyableRapeTable:onDetach()
	self.av.hasRapeTable = false;
	setCollisionMask(self.components[1].node, self.collisionMaskBackup);
	for _, object in pairs(self.cutterExtraObjects) do
		local objectNode = Utils.indexToObject(self.av.components, object.index);
		if objectNode ~= nil then
			setVisibility(objectNode, not object.showOnAttach);
		end;
	end;
	self.av = {};
	self:setAnimationTime(1, 0);
	--setMass(self.components[1].node, self.massBackup);
	setCenterOfMass(self.rootNode, 0, 0, 0);
end;